#include <iostream>
using namespace std;
void f1(int y,int a[],int b[]){
    int sum1=0;
	int j=0;
	while(y-a[j]>=0){
		if(b[j]<=y-a[j]){
			sum1 += b[j];
		}else{
			sum1 += y-a[j]+1;
		}
		j++;
	}
	cout<<sum1;
}
int main(){
	int n,q;
	cin>>n>>q;
    int a[n];
    int b[n];
	for(int i=0;i<n;i++){
		cin>>a[i]>>b[i];
	}
	int x[q];
	for(int i=0;i<q;i++){
		cin>>x[i];
	}
	for(int i=0;i<q;i++){
		int y = x[i];
		f1(y,a,b);
		cout<<"\n";
	}
    return 0;
}